/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.*;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author wwerapun
 */
public class ReadNS2file {

    int edgeCount = 0;
    int nodeNum = 0;
    // for node connection
    ArrayList edgeRow = new ArrayList();
    ArrayList edgeCol = new ArrayList();

    public static void main(String args[]) {
        ReadNS2file rn = new ReadNS2file();
        rn.readFromFile("res\\out.tcl"); //  %NB_PROJECT_ROOT%\res\\out.tcl
        rn.countDegree();
        System.out.println("edge count = " + rn.edgeCount);
    }

    public void readFromFile(String fileName) {
        // --------- Read node and edge from File ----------------
        try {
            FileInputStream fstream = new FileInputStream(fileName);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader bf = new BufferedReader(new InputStreamReader(in));

            String aktLine;

            while ((aktLine = bf.readLine()) != null) {
                if (aktLine.length() == 0) {  // then do nothing - next line
                    continue;
                }
                if (aktLine.charAt(0) == '#') {  //Comment line
                    continue;
                }
                // node number line
                if (aktLine.contains("set num_node")) { 
                    StringTokenizer t = new StringTokenizer(aktLine); 
                    t.nextToken(); //first token "set:"
                    t.nextToken(); //first token "num_node"
                    nodeNum = Integer.parseInt(t.nextToken()); // 100
                    //System.out.println("nodeNum (from file) = " + nodeNum);
                    continue;
                }
                if (aktLine.contains("duplex-link")) {
                    //   $n  (    0     )       $n  (    1      )
                    // \\$n\\( (\\d+) \\) \\s \\$n\\( (\\d+)  \\)
                    Pattern pat = Pattern.compile("\\$n\\((\\d+)\\)\\s\\$n\\((\\d+)\\)");
                    Matcher fit = pat.matcher(aktLine);

                    if (fit.find()) {
                        edgeRow.add(fit.group(1));
                        edgeCol.add(fit.group(2));
                        edgeCount++;
                        /*
                        for (int i = 1; i <= fit.groupCount(); i++) {
                            System.out.print("We have " + fit.group(i));
                        }*/
                    }
                    continue;
                }
            }
            in.close();
        } catch (Exception e) {
            System.err.println("File input error");
        }
    }

    public void countDegree() {
        int nodeFreq[] = new int[100];

        for (int iEdge = 0; iEdge < edgeCount; iEdge++) {
            int x = Integer.parseInt((String) edgeCol.get(iEdge));
            int y = Integer.parseInt((String) edgeRow.get(iEdge));
            nodeFreq[x]++;
            nodeFreq[y]++;
        }

        for (int y = 0; y < 100; y++) {
            if (nodeFreq[y] > 7) {
                System.out.println("nodeFreq[" + y + "] = " + nodeFreq[y]);
            }
        }
    }
}
